TRIK Studio 3.3.0-b2:
- Добавлена возможность сохранять подпрограммы для дальнейшего использования в других проектах, сохранение происходит в репозиторий подпрограмм. Также добавлена возможность экспорта/импорта файла, содержащего подпрограммы.
- В настройки подпрограмм добавлен новый тип аргумента -- число с плавающей точкой.
- Исправлены некоторые ошибки вывода типов для текстового языка.
- Добавлена новая возможность работы с блоками на сцене. Теперь доступна возможность замены блоков и возможность создать блок на связи.
- Добавлена поддержка работы с камерой для ТРИК в режиме интерпретации текстовых языков в симуляционной модели мира (доступна через меню настройки).
- Улучшен вывод массивов при использовании функции "print".
- Добавлена возможность сбросить все настройки к настройкам по-умолчанию (меню Файл).
- Исправлены несоответствия работы сенсора линии для ТРИК.
- Сообщения об ошибках при работе с условными конструкциями квадракоптера Пионер стали более простыми и информативными.
- Исправлена возможность масштабирования инструментов в симуляционной модели мира.
- Значительно улучшена работа текстового редактора среды: 
	- Добавлена возможность комментировать участки кода сочетанием клавиш ctrl+/
	- Улучшена возможность поиска (ctrl+f), добавлена возможность поиска в обратном направлении и поиска с заменой (ctrl+h).
	- Добавлена возможность перехода на конкретную строку и столбец (ctrl+l)
- Добавлена возможность поиска блоков на сцене (ctrl+f), поиск осуществляется по всем свойствам и имени блока.
- Добавлена возможность загружать программы на робот EV3 по usb-кабелю на linux.
- Добавлена возможность загружать и исполнять на работе, и интерпретировать программы в симуляционной модели мира на языке Python для контроллера ТРИК (экспериментально).

TRIK Studio 3.3.0-b1:
- Значительно улучшена работа генераторов кода для платформы ТРИК. Количество ошибок "невозможно сгенерировать структурированный код" уменьшилось.
- Симуляционная модель мира улучшилась. Добавилась поддержка реалистичной физики, основанной на физическом движке Box2D. Добавились объекты, с которыми робот может взаимодействовать (банки, мячи).
- Добавлена частичная поддержка языка Python для платформы TRIK.
- Улучшена поддержка визуального языка для квадракоптера Геоскан Пионер.
- Улучшена работа с "тяжелыми" изображениями в 2D модели мира.
- Улучшена работа с роботами NXT. Исправлены некоторые проблемы подключения. Исправлена/добавлена возможность прошивать контроллер NXT на Linux и загружать программы для автономного исполнения.
- Исправлены цвета для закрашиваемых фигур в 2D модели.
- Иcправлен порядок добавления элементов на 2D модели мира.
- Исправлена ошибка отсутствия прав, вызывающая падения, при автосохранении файлов.
- Исправлен порядок генерации подпрограмм.
- Исправлена ошибка открытия ассоциированных со средой qrs-файлов, содержащих пробелы.
- Исправлены блоки моторов для EV3. Свойство float/break добавлено для блока "моторы стоп".
- Более мелкие исправления и улучшения, в том числе документации.


TRIK Studio 3.2.0:
- Теперь можно настраивать внешний вид пользовательских блоков (подпрограмм) и менять список их параметров (с этого момента в визуальном языке поддержана полноценная рекурсия).
- В 2D модели теперь работают все действия на панели инструментов (изменение масштаба, отмена и повтор).
- На поле 2D модели можно загружать свои картинки, примеры полей в формате svg добавлены в папку приложения (по умолчанию C:\TRIKStudio\fields\images).
- Если по визуальной диаграмме сгенерировать код, то во время исполнения на 2D модели или в режиме интерпретации диаграммы, на роботе будут подсвечиваться соответствующие строчки кода.
- Во встроенном текстовом языке поддержаны escape-последовательности (теперь работает \n).
- Значительно оптимизирован режим интерпретации по Wi-Fi на ТРИК.
- В режиме EV3 теперь доступны блок ожидания и блок калибровки гироскопа, блоки отправки и приема сообщений для коммуникации с другим роботом, блоки калибровки компаса, добавлены новые устройства (компас, irseeker, датчик цвета).
- Картинки роботов в 2D модели теперь можно менять из настроек.
- Теперь можно исполнять программу для ТРИК на JavaScript в 2D модели.
- Исправлено перетаскивание набора стен в 2D модели мира.
- Добавлена экспериментальная поддержка квадрокоптера Геоскан Пионер.
- Теперь можно запускать Геймпад для ТРИКа, winSCP, PuTTY из меню <<Инструменты>>.
- В режиме текстового программирования появился поиск по тексту.
- Значительно улучшено поведение стрелок на диаграмме (копирование/вставка, отмена перемещения, отображение текста на стрелках).
- Исправлено большое количество сценариев приводящих к падению TRIKStudio.


TRIK Studio 3.1.4:
- Драйвер Fantom больше не необходим для работы TRIK Studio с NXT! Большое количество жалоб пользователей о некорректной работе драйвера Lego Fantom побудили нас реализовать функциональность этого драйвера собственными силами. 
	В случае, если драйвер для работы с NXT не найден, среда предложит установку своего драйвера. Для тех пользователей, у которых уже установлен драйвер Fantom ничего не изменится: среда по-прежнему совместима с официальными драйверами.
	Это также хорошая новость для пользователей Mac OS x64 и Linux: среда теперь официально поддерживает работу с NXT на этих операционных системах, в то время как Lego Fantom на них недоступен.
- Добавлена экспериментальная поддержка генерации в Паскаль для TRIK! Используется компилятор PascalABC.NET, который надо установить отдельно.
- Скорость работы редактора  диаграмм ускорена во много раз.
- Процесс перепрошивки NXT теперь отображает прогресс.
- В 2D модели теперь отображаются оси координат.
- Исправлены некоторые ошибки поддержки EV3, добавлена поддержка гироскопа.
- Улучшено поведение эмулятора гироскопа в 2D модели.
- В 2D модели теперь возможно определять по энкодерам, "застрял" ли робот.
- Текстовые поля на сцене редактора теперь сохраняют значение в момент редактирования, а не снятия с них фокуса.
- Исправлена различное поведение сенсора света на различных машинах.
- Исправлено падение при создании подпрограммы на Mac OS X.
- Более мелкие исправления и улучшения, в том числе документации.


TRIK Studio 3.1.3:
- Практически полная поддержка EV3! Реализован режим автономной работы со стандартной прошивкой EV3, двумерная модель для EV3, поддержаны новые сенсоры, значительно улучшены старые механизмы работы среды с устройством EV3.
- Значительно улучшена производительность редактора. Теперь многие операции (такие как отрисовка элементов, вставка большого количества элементов и их выделение) работают в десятки раз быстрее!
- Добавлена экспериментальная поддержка гироскопа и акселерометра в 2D модели.
- Среда больше не "подвисает" на некоторое время, если попробовать загрузить программу на неправильный IP-адрес.
- Параллельные задачи для Lego NXT теперь работают значительно лучше. Переключение потоков теперь срабатывает при выполнении блоков ожидания (раннее оно происходило лишь при завершении работы потоков). Также рисование на экране теперь может осуществляться из нескольких потоков.
- Поддержан сенсор касания для ТРИК.
- Механизм увеличения номера сгенерированного файла теперь более интеллектуален: номер файла не будет увеличен, если только пользователь не редактировал сгенерированный файл самостоятельно. Доступно только для Windows.
- Обновления в документации.
- В установщик добавлен пульт управления роботом с компьютера.
- Блок завершения потока имеет значение 'main' по умолчанию.
- Конфигурирование сенсоров может теперь может производиться во вкладке с подпрограммой.
- Выбор COM-порта для режима общения с Lego (NXT или EV3) по Bluetooth теперь может производиться на панели инструментов, больше нет необходимости открывать окно настроек и искать это поле там.
- Кнопки на эмуляторе контроллера ТРИК теперь имеют стрелочки.
- Исправлено множество ошибок, самые значительные:
	- Восстановлена корректная работа модуля взаимодействия с драйвером fantom для NXT.
	- Исправлено "подвисание" среды, которое могло начинаться через некоторое время после начала отрисовки графиков.
	- Исправлена невозможность выбрать сенсор в списке под координатной плоскостью графиков при открытии существующего проекта.
	- Исправлены некоторые потенциальные проблемы, которые могут возникать при работе с защищенным от записи диском.
	- Исправлено "застревание" в стене датчика касания в 2D модели.
	- Исправлены некоторые падения среды при удалении элементов из 2D модели.
	- Исправлена работа блока ожидания цвета в режиме Lego NXT.
	- Исправлено поведение стенок и прямых линий в 2D модели при изменении их формы с зажатой клавишей "shift".


TRIK Studio 3.1.2:
- Улучшения в работе версии для Mac OS X:
	- Поддержана работа с драйвером Fantom для NXT: теперь с NXT на Mac можно работать и по USB-проводу.
	- Среда теперь не "падает" при закрытии.
	- Улучшения в работе инсталлятора и структуре директорий среды.
- Улучшения в работе проверяющей системы, практически полностью поддержана функциональность для онлайн-курса.
- Траектории поведения робота в 2D модели теперь не должны различаться при запуске одной и той же программы (раннее такое было возможно в некоторых случаях).
- В 2D модели появились кривые Безье и прямоугольники.
- В 2D модель добавлена кнопка "режим тренировки", позволяющая отключить систему проверки на время разработки решения.
- Загрузка ПО на ТРИК теперь возможна на Linux и Mac OS X.
- У нас появился сплеш-скрин!
- "Старый корпус" и "Новый корпус" в настройках ТРИК переименованы в "модель-2014" и "модель-2015".
- Добавлена поддержка математической функции atan2.
- Добавлен блок запуска видеотрансляции на ТРИК.
- Добавлены примеры "Сегвей" и "Пакман" для ТРИК.
- Теперь система по умолчанию предлагает сохранять проекты в папку "Документы" (на всех платформах).
- Добавлено автоматическое заполнение поля имени файла в диалоге "Сохранить как...".
- Из диалога настроек убраны пункты настройки шумов, теперь их можно найти справа в самой 2D модели.
- Имена программ для NXT теперь автоматически обрезаются до 15 символов (как того требует стандартная прошивка NXT).
- Добавлена возможность писать названия портов по-русски
- Исправлена ошибка совместимости на Ubuntu 14.04 в Linux-версии при отсутствии пакета gcc-4.9.
- На Linux-версии снова можно запускаться без указания LD_LIBRARY_PATH.
- Множество исправлений:
	- Исправлено странное поведение размера окна при переключении в различные режимы.
	- Исправлена работа блоков ожидания с датчика света и нажатия кнопки.
	- Исправлены предупреждения о неизвестных портах 1..4 при генерации кода для ТРИК.
	- Исправлены неточности в работе сенсора линии.
	- Исправлено некорректное поведение 2D модели при переключении вкладок во время работы интерпретатора.
	- Исправлено "пунктирное" рисование на дисплее 2D модели в режиме ТРИК.
	- Исправлено падение среды при удалении блоков во время исполнения программы.
	- Исправлена пропадающая кнопка остановки программы при повторном нажатии на пункт "2D".
	- Улучшена работа блока соединения потоков (в режимах интерпретации и генерации).
	- Исправлено странное поведение курсора в поле ввода IP-адреса при вводе "в середину" строки.
	- Значения блока ожидания энкодеров по умолчанию теперь E3 или B3.
	- Исправлена невозможность повернуть робота из-за всплывающих настроек.
	- Исправлена работа с файлами, содержащими в своем имени точки.
	- Исправлено поведение редактора, приводящее к удалению двух элементов из контекстного элемента вместо одного.
	- Исправлена генерация кода в примере с конфигурацией WiFi на ТРИК.


TRIKStudio 3.1.1:
- Официально поддержана платформа Mac OS X.
- Добавлена поддержка для новых корпусов ТРИК (с энкодерами на портах E1-E4 и т.д.).
- Настройки IP-адреса робота перенесены с вкладки настройки сенсоров на панель инструментов.
- Добавлен пункт меню "Вид" -> "На главную", позволяющий открыть главную диаграмму, если она была случайно закрыта.
- Улучшен процесс прошивки контроллеров TRIK из среды. Теперь не показывается черное окно консоли WinScp, а также пишутся сообщения о статусе загрузки на панель снизу.
- Добавлена возможность рисовать эллипсы с заливкой в 2D модели.
- Отключено автоматическое выравнивание стенок в 2D модели при изменении параметров сетки. Теперь нельзя случайно "испортить" положение стенок.
- Возвращены пропавшие из режима генерации переменные, необходимые для работы с пультом управления.
- Файлы с расширением .js добавлены в фильтры диалога выбора файлов.
- Восстановлена работа комбинации клавиш "Ctrl+Shift+T".
- Исправлено падение при исполнении рекурсивной программы без таймеров.
- Отображение кнопок переключения режима сбоку теперь подстраивается под разрешение экрана, чтобы не допустить бесполезной траты пространства на экране.
- Улучшения в работе системы проверки заданий в 2D модели.

TRIKStudio 3.1.0:
- Продукт теперь распространяется по лицензии Apache License 2.0 вместо GNU General Public License 3.0.
- Значительно переработан интерфейс:
	- Введено два режима работы: режим разработки и режим отладки. В каждом из режимов ненужные панели автоматически скрываются. Например, палитра блоков не нужна при отладке программы на 2D модели и в режиме написания кода. Переключение между режимами происходит по нажатию Ctrl+1 - Ctrl+2 или по клику на панель внизу окна.
	- Существенно улучшен интерфейс 2D модели: теперь он более минималистичен и интуитивен, 2D модель по умолчанию "встроена" в окно среды. Её можно по-прежнему "вытянуть" в оконный режим.
	- Теперь вместо нескольких групп кнопок запуска и остановки исполнения в режиме генерации или 2D-моделирования доступно явное переключение между режимами, кнопки запуска и остановки, соответственно, выполняют различные действия для различных режимов.
	- С панели инструментов убраны некоторые нерелевантные пункты (создание новой диаграммы, печать), теперь они доступны только из меню.
	- Большие кнопки управления палитрой убраны (ввиду их нерелевантности), вместо них добавлен поиск по палитре.
- Добавлено множество новых блоков:
	- Блоки продвинутой работы с потоками -- теперь возможен обмен сообщениями, слияние потоков и прекращение работы потоков.
	- Блок "Конец условия"
	- Блоки работы с файлами
	- Блок "Положить код кнопки в переменную"
	- Блок "Случайное число" - раньше такая функция была доступна только в текстовой форме (функция random).
- Добавлена эмуляция видеокамеры в режиме сенсора линии в 2D модели.
- В 2D модели на узлах сетки теперь пишется метраж поля (в сантиметрах).
- Реализован механизм всплывающих сообщений, появляющихся при выполнении блока синтеза речи в 2D модели.
- Реализован механизм проверки ограничений на 2D модели. Теперь можно накладывать различные требования на поведение робота (пока что в текстовом виде на специальном языке).
- Добавлена поддержка регионов в 2D модели. Регионы могут использоваться как для декорирования модели мира (например, для задания зон старта/финиша), так и для задания ограничений на расположение робота (например, что робот не имеет права выезжать из заданной зоны).
- Добавлено сохранение проекта в виде упражнения. Это позволяет отключать редактируемость тех или иных частей 2D модели для честного прохождения того или иного задания.
- Добавлены примеры выхода из лабиринта (в папке examples/trik/stepic).
- Добавлена возможность явного задания стартовой позиции робота. Она отображается в виде красного крестика, который можно перемещать и задавать его направление.
- 2D модель теперь общая для всех вкладок: теперь элементы 2D модели не пропадают при переключении на подпрограмму.
- Добавлен генератор в F# для ТРИК.
- Расширен текстовый язык TRIK Studio:
	- Добавлена поддержка двумерных массивов в интерпретаторе.
	- Добавлена функция sensor(), позволяющая получить значение сенсора на указанном порту. В отличие от сенсорных переменных, эта функция позволяет писать более гибкий код.
	- Добавлена поддержка функций min и max
	- Добавлена функция print, позволяющая напечатать строку, число или массив в консоль робота. Вывод отображается на панели в нижней части окна. Данные с консоли ТРИК теперь перенаправляются в среду в режиме интерпретации.
- Добавлена возможность отключать жесты мышью в настройках.
- Огромное количество мелких исправлений, самые значимые:
	- Исправлена работа авто-обновлений.
	- Исправлено случайное перецепление некоторых стрелочек к портам, к которым они не были прицеплены в последний раз.
	- Исправлено "наезжание" текста под пиктограммой при увеличении шрифта (в рамках одного блока).
	- Маркер "итерация" переименован в "тело цикла".


TRIKStudio 3.0.2:
- Исправлено неверное сообщение о несовместимости версии ПО ТРИК.
- Добавлен пример, позволяющий конфигурировать WiFi-сеть на роботе, см. examples/trik/configureNetwork.qrs.
- Добавлены иконки для блоков работы с Android-пультом.
- Исправлена генерация для сенсора цвета ТРИК.
- Свойство "Команда" блока "Системный вызов" в ТРИК теперь вычислимо (следовательно, теперь команду надо заключать в кавычки).
- Сообщения об ошибке совместимости версий и ошибки с робота сделаны более ясными.


TRIKStudio 3.0.1:
- Добавлены блоки и сенсорные переменные для работы с Android-пультом на ТРИК.
- Существенно улучшена диагностика ошибок в текстовых выражениях внутри блока: теперь сообщается имя свойства, где допущена ошибка, выдаётся ошибка в случае использования неизвестного идентификатора, номера строк и колонок теперь начинаются с 1, а не с 0.
- Блоки ожидания кнопок для каждого конструктора заменены одним блоком с полем, позволяющим выбрать нужную кнопку. Попутно исправлена проблема с кнопкой Escape на ТРИК. Из старых сохранений автоматически удалятся старые блоки работы с кнопками, после чего новые блоки надо добавить вручную.
- Поправлены имена пакетов в инсталляторе, так что предыдущая версия не сможет автоматически обновиться. Эту версию надо скачать и поставить вручную.


TRIKStudio 3.0.0:
- Значительно улучшен текстовый редактор (исправлены проблемы с табуляцией, автодополнение сделано более удобным и т.д.).
- Исправлено поведение палитры в случае добавления нескольких подпрограмм.
- Исправлена работа датчиков света в режиме 2D модели NXT.
- Исправлено положение кнопок контроллера TRIK в 2D модели.
- Исправлено падение при попытке запуска блока "Очистить экран" в режиме интерпретации на реальном устройстве TRIK.
- Зарезервированные переменные теперь убираются из окна "Переменные" при переключении типа конструктора.
- Исправлен путь, предлагаемый по умолчанию установщиками для Linux.


TRIKStudio 3.0.0-RC2
- Переведены на русский язык надписи в редакторе свойств
- Блок "Сказать" теперь позволяет писать выражения в свойстве "Текст". Это означает, что теперь фраза должна быть заключена в кавычки. Старые файлы сохранений будут автоматически преобразованы к новому формату.
- Исправлено падение при закрытии среды после того, как была осуществлена интерпретация на реальном устройстве TRIK.
- Отключенные блоки теперь просто игнорируются интерпретатором, а не выдают сообщение об ошибке.
- Исправлены названия цифровых портов в сгенерированном коде.
- Исправлен механизм отмены удаления связи.
- Новые иконки для сообщений и маркеров.
- Исправлена ошибка, из-за которой приходилось перезапускать среду для работы с другим контроллером TRIK.
- Исправлена ошибка, из-за которой в некоторых случаях исчезали кнопки работы с устройствами NXT.


TRIKStudio 3.0.0-RC1
- Обновления в документации.
- Начиная с данной версии в среде будет присутствовать возможность автоматического обновления. Среда сама будет следить за выходом версий и предлагать обновиться, отключить данную возможность можно в настройках.
- Улучшена поддержка EV3: добавлена возможность работы с сенсорами и кнопками на корпусе робота.
- Блок вывода текста теперь имеет новый синтаксис: теперь можно вывести на экран произвольную строку. Например, вместо выражения a=$a следует писать "a=" .. a, где две точки означают конкатенацию. Подробности см. в документации.
- Улучшения в работе текстового языка: добавлены некоторые действия, исправлено множество ошибок.
- В режиме TRIK теперь присутствует возможность проверки совместимости версий ПО на роботе и TRIK Studio, а также присутствует возможность загрузки ПО на робота из среды.
- Восстановлена работа подпрограмм в режиме генерации кода.
- Исправлены критические ошибки генераторов кода для случая параллельных задач.
- Улучшено взаимодействие робота и среды в режиме TRIK, исправлены некоторые ошибки интерпретатора TRIK.
- Работа с 2D моделью сделана более удобной: теперь можно удалять предметы из контекстного меню, стенки ведут себя адекватно при изменении сетки, исправлены некоторые ошибки.
- Исправлены некоторые пропавшие возможности работы с NXT: восстановлена работа сенсора цвета, дисплея в режиме генерации и проверки наличия драйвера Fantom.
- Улучшения в работе инсталлятора: теперь он полностью переведен на русский язык, а также позволяет установить среду в папку, уже содержащую старую версию программы.
- Обновлены некоторые иконки.
- Добавлен режим рисования следов в 2D модели, включаемый блоком "Опустить маркер" и выключаемый блоком "Поднять маркер".
- Улучшена эргономичность окна рисования графиков.
- Убраны неактуальные режимы работы в блоках управления видеокамерой.


TRIKStudio 3.0.0-b2
- Полноценная поддержка стандартных математических функций
- Добавлена поддержка режима интерпретации для конструктора ТРИК
- Исправлено некорректное расположение текстовых меток в блоках работы с видеокамерой
- Исправлено падение, случающееся время от времени при удалении группы элементов
- Исправлены некоторые падения при обработке некорректного кода в блоке "Функция"
- Восстановлено выделение мышью текста в режиме редактирования текста на сцене
- Ошибки текстового языка в режиме генерации кода теперь указывают на блок, в котором допущены эти ошибки
- Язык по умолчанию сделан автоопределяющимся по языку, выбранному в настройках операционной системы
- IP-адрес робота ТРИК по умолчанию сделан 192.168.1.1
- В инсталлятор включена свежая версия прошивки контроллера ТРИК
- В режиме работы с NXT добавлены русскоязычные синонимы портов моторов. Теперь русская "С" не путается с английской, а также можно называть моторы "А", "Б" и "В"
- Исправлено некорректное поведение стрелок в режиме редактирования надписи на сцене
- Добавлено генерирование констант в режиме работы с ТРИК
- Переменные, объявленные в блоки "Инициализация переменной" и "Значение детектора в переменную" теперь учитываются генератором
- Исправлено внезапное появление набора зарезервированных идентификаторов в окне "Переменные" и сгенерированном коде после переключения режима работы с конструктором
- Добавлена возможность писать код на целевом языке генерации в блоке "Системный вызов". Для этого нужно поставить галочку возле свойства "Код"
- Исправлено наезжание надписей в блоке "Угловой сервомотор"
- Убрано прокручивание сцены при передвижении блоков стрелками
- Добавлено сохранение выбранных панелей при переходе в полноэкранный режим: к примеру, при восстановлении боковых панелей теперь не всегда будет выбрана панель "Блоки"


TRIKStudio 3.0.0-b1
- Среда переименована из QReal:Robots в TRIKStudio
- Добавлена поддержка конструктора ТРИК
  - Работа осуществляется в двух режимах: двухмерной модели и генерации и загрузки программ на робот по WiFi
  - Поддержаны следующие датчики и устройства робота:
	- Видеокамера (режим детектирования линии, объекта, работы как датчика цвета) (только для реального робота)
	- Динамик (воспроизведение звукового файла, синтез речи) (только для реального робота)
	- Сеть (посылка сообщений на другие роботы и приём сообщений с других роботов, с возможностью работать с 0 до 100 роботов одновременно) (только для реального робота)
	- Гироскоп (только для реального робота)
	- Акселерометр (только для реального робота)
	- Датчик света
	- Инфракрасный датчик расстояния
	- Кнопки робота
	- Датчик движения (только для реального робота)
	- Моторы (силовые моторы и угловые сервомоторы)
	- Энкодеры силовых моторов
	- Дисплей (рисование графических примитивов, смайлики)
	- Светодиод
	- Доступ к командам операционной системы робота (только для реального робота)
  - Добавлен набор примеров программ для ТРИК
- Добавлена поддержка конструктора Lego EV3 (точнее, её первая пробная версия)
  - Работа осуществляется только в режиме интерпретации управлением роботом по Bluetooth
  - Поддержано управление моторами робота, звуком, и рисование на экране
- Полностью переписан механизм работы с текстовым кодом в свойствах блоков
  - Поддержка массивов, в виде a = {1, 2, 3}; a[0] = 5;
  - Многие свойства блоков теперь допускают выражения, например, для задания портов моторов можно использовать массивы
  - Несколько изменился синтаксис языка, теперь мы следуем синтаксису Lua 5.3 (той его части, что относится к выражениям и присваиванию)
	- Присваивание можно выполнять сразу нескольким переменным в одном операторе, так: a, b = 1, 2
	- Оператор неравенства можно писать как ~= или как !=
	- Оператор логического отрицания пишется как not, а не как !, как было принято раньше. Логические "и" и "или" допускают как традиционный синтаксис (&& и || соответственно), так и "Lua-шный"
	  (and и or соответственно)
	- Доступны побитовые операции (побитовый сдвиг, побитовое "и", побитовое "или", побитовое отрицание)
	- Доступна операция возведения в степень (пишется как ^)
	- Оператор конкатенации строк пишется как "..", оператор "+" не определён для строкового типа
	- Доступен оператор получения длины строки, пишется как "#"
  - Автоматический вывод типов сохранён, явно описывать переменные и указывать их тип, как и раньше, не надо
- Добавлено кеширование отрисовки блоков на сцене, что примерно вдвое ускорило работу среды, это особенно заметно на слабых компьютерах
- Добавлена поддержка параллельных задач в режиме генерации кода, как для Lego NXT, так и для ТРИК
- Добавлен оператор выбора (switch), поддержан как в режиме интерпретации (на реальном роботе и в двухмерной модели), так и при генерации в NXT и ТРИК
- Добавлен блок инициализации переменной
- Используется новый движок инсталлятора, Qt Installer Framework
  - Возможность выбора компонентов для установки
  - Инсталлятор для Linux
- Выбор языка пользовательского интерфейса в настройках
  - Файлы с переводом больше не "вшиты" в бинарные файлы и могут отдельно устанавливаться или обновляться новым инсталлятором
  - Настройки языка также влияют и на блоки, названия и имена свойств можно отображать по-русски и по-английски
- Недоступные в данном режиме блоки (например, “Ждать сенсор звука” в двухмерной модели) отображаются в палитре серым и недоступны для добавления на диаграмму
- Исправлены проблемы с работой на сенсорных экранах в Windows 8
- Улучшена двухмерная модель
  - Переделан интерфейс, теперь настройки модели сгруппированы по трём вкладкам, так что окно двухмерной модели целиком помещается даже на маленькие экраны
  - Можно выбирать, какой мотор отвечает за левое и правое колесо
  - Поправлена проблема с исчезновением стенок при переключении в режим сетки
  - Исправлены мелкие проблемы с выбором ширины рисуемой линии
  - Исправлены проблемы, связанные с загрузкой модели мира и позиционированием сенсоров
- Некоторые иконки заменены на новые
- Добавлено отображение мышиных жестов во всплывающих подсказках в палитре
- Теперь можно копировать имена переменных из окна "Переменные"
- Ошибки при двойном щелчке на них в окне ошибок выделяют соответствующий элемент на сцене
- Переменная time сделана функцией time()
- Исправлено множество ошибок в генераторах
- Код по диаграмме генерируется не в "example0.qts" всегда, а в файл, соответствующий имени проекта
- Если в сгенерированном коде были ручные изменения, он не будет затёрт при повторной генерации (работает только для Windows)
- Теперь система следит за версией сохранения, в будущем это позволит избежать несовместимости сохранений
- Добавлена запись в лог основных операций, теперь разработчикам может быть проще разбираться в проблемах
- Исправлены некоторые проблемы с копированием-вставкой
- Добавлена возможность экспорта показаний сенсоров в файл, через окно "Графики"
- В блоке "Напечатать текст" теперь можно печатать значения переменных, для этого надо написать "$" перед именем переменной, например, так: $sensor1


QReal:Robots 2.5.3
- Добавлен генератор кода с goto-конструкциями. Он вступает в действие в тех случаях, когда диаграмма не может быть сгенерирована в структурированный код
- Добавлена переменная time, хранящая в себе количество миллисекунд, прошедших с момента начала исполнения программы
- Изменения в именовании сенсорных переменных: теперь их следует писать со строчной буквы
- Более интеллектуальный алгоритм назначения номера сгенерированного примера: теперь сгенерированный код перетирает старый, если он не был изменен пользователем. В противном случае номер сгенерированного примера увеличивается.
- Добавлена возможность удалять элементы жестом мыши. Для этого достаточно перечеркнуть элемент влево-вниз так, чтобы центр жеста попадал на элемент
- Исправлено исчезание сцены при ее масштабировании после применения настроек
- Исправлено падение при применении настроек при открытой текстовой вкладке
- Исправлено генерирование кода и файлов статистики в директорию qrs-файла, если он был открыт из проводника Windows
- Исправлена некорректная генерация кода распознавания цвета в nxtOSEK при использовании сенсорных переменных
- Первое чтение с сонара в режиме nxtOSEK теперь по умолчанию происходит в момент исполнения кода инициализации, в противном случае после первого обращения к сонару необходимо ждать некоторое время
- Показания сенсора света в nxtOSEK инвертированы
- Исправлено некорректное размножение кода генератором на некоторых диаграммах
- Добавлены всплывающие подсказки с указанием порта, к которому подключен сенсор в 2D модели
- Улучшения в работе на тач-мониторе: добавлено автоматическое показывание экранной клавиатуры, исправлено падение при изменении режима палитры в тач-режиме, реализовано выделение элемента тапом
- Размер пунктов на панелях инструментов сделан настраиваемым (Настройки -> Разное), размер по умолчанию увеличен
- Добавлен пункт "Вырезать"
- Исправлена невидимость линкера около элемента "Начало" при создании диаграммы
- Интервал автосохранения по умолчанию уменьшен до 1 минуты


QReal:Robots 2.5.2
- Восстановлен старый, нереалистичный физический движок в 2D модели. При этом возможно переключение между реалистичным и нереалистичным движками (пункт "Реалистичная физика" в 2D модели).
- Блок "Начало" теперь сразу располагается на диаграмме
- Переключение сенсоров в 2D модели теперь действует и на глобальную конфигурацию тоже
- Улучшена поддержка touch-мониторов
- Исправлена переинициализация 2D модели при активной недиаграммной вкладке
- Множество других мелких исправлений и улучшений 2D модели


QReal:Robots 2.5.1
- Обновления в документации: добавлено описание нововведений версии 2.5.0
- Улучшен пользовательский интерфейс стартовой вкладки
- Процесс переключения между 2D моделью и реальным роботом сделан более быстрым и удобным: соответствующие пункты добавлены на панель инструментов
- Исправлена ошибка, приводившая к автоматическому зацикливанию связей при небольшом расстоянии между блоками
- Убрана кнопка запуска программы на роботе, теперь система предлагает запустить программу сразу после загрузки. Автоматическое предложение запуска может быть отключено в настройках, вкладка "Роботы"
- Внесено большое количество исправлений в поведении прокрутки и масштабирования сцены
- Исправлено некорректное поведение ассоциаций .qrs-файлов со средой на некоторых платформах
- Синхронизированы пункты на панелях инструментов и в меню
- Отключены ненужные пункты в меню при открытой стартовой вкладке, а также вкладке "Жесты мышью"
- Добавлено запоминание последнего выбора в диалогах сохранения и открытия, при открытии проекта по умолчанию теперь предлагается открыть какой-либо пример
- Внесены некоторые исправления в стандартные примеры
- Точка создания элемента жестом мыши перенесена в такое место, что центр элемента (а не левый верхний угол, как раньше) совпадает с центром жеста
- Текстовое поле более не мешает добавить точку излома в центре связи, а так же не останавливает прямоугольник выделения (как это иногда случалось в прошлых версиях)
- Отключена возможность перетаскивать робота за стрелку поворота в 2D модели
- Исправлено некорректное поведение стенок в 2D модели, время от времени проявляющееся при их перетаскивании при включенной сетке
- Множество других улучшений в интерфейсе и поведении элементов на сцене


QReal:Robots 2.5.0
- Переработан пользовательский интерфейс создания/открытия проекта: убрано стартовое окно, добавлена стартовая вкладка
- Существенно улучшена симуляция физики в двухмерной модели: моделируется тяга двигателей, инерция робота, сила реакции стен, сила трения, моменты всех сил. Робота теперь разворачивает и иногда отбрасывает при ударе о стену
- Добавлены графики текущих показаний сенсоров робота
- Добавлена возможность редактировать код на текстовых языках и загружать на робот отредактированную программу
- Улучшена подсветка синтаксиса и функциональность редактора для текстовых языков (теперь используется компонент Scintilla, http://www.scintilla.org/)
- Добавлен новый текстовый язык --- Школьный алгоритмический язык, предназначенный для демонстрации перехода от графической формы программы к текстовой. Программы на этом языке нельзя загрузить на робот, он служит только для иллюстрации текстового программирования.
- Добавлена кнопка, позволяющая загрузить и запустить визуальную или текстовую программу на роботе
- Добавлена кнопка в двухмерной модели, возвращающая робот в состояние на момент запуска программы
- Несколько поправлен интерфейс окна двухмерной модели: инструменты рисования теперь "залипают" при выборе, цвета линии теперь пишутся по-русски, запоминаются размеры и положение окна
- Исправлено медленное переключение между вкладками
- Внесено множество других исправлений и визуальных улучшений


QReal:Robots 2.4.3
- Обновлены генераторы: поддержан значительно больший спектр потоков управления
- Добавлен второй набор примеров из книги С.А. Филиппова (спасибо М.М. Киселеву)
- Исправлены некоторые неудобства при работе с тачевыми экранами


QReal:Robots 2.4.2
- Добавлены примеры из книги С.А. Филиппова (папка examples/Filippov-book-examples)
- Обновлена документация
- Несколько мелких исправлений


QReal:Robots 2.4.1
- Исправлено поведение подпрограмм в интерпретаторе
- Изменён шрифт по умолчанию на более крупный и читаемый
- Добавлено ограничение в максимум 100 потоков при интерпретации
- Окно 2D модели теперь оказывается поверх всех окон при запуске интерпретации
- Исправлено падение при остановке интерпретации при зацикленном блоке "Параллельные задачи"
- Исправлено падение при передвижении нескольких выделенных элементов стрелками клавиатуры
- Переведены некоторые надписи в пользовательском интерфейсе
- Пиктограмма блока "Параллельные задачи" повернута
- Исправлено использование прямоугольных связей по умолчанию
- Исправлены падения при некоторых переходах к реализации подпрограммы
- Добавлена синхронизация блока "Играть звук" со временем в 2D модели
- Задано значение громкости в примере touchObstacle.qrs
- Уменьшена величина изменения масштаба по соответствующим кнопкам
- Исправлены некоторые другие падения, множество ускорений в работе 2D модели


QReal:Robots 2.4.0
- Добавлены подпрограммы
- Добавлена поддержка работы с дисплеем робота
- Добавлена поддержка работы с кнопками робота
- Добавлена эмуляция дисплея и кнопок робота в 2D модели
- Добавлено рисование блоков жестами мышью, см. "Инструменты" -> "Жесты мышью"
- Добавлена поддержка новых сенсоров: звука и гироскопа
- Добавлен режим рисования лабиринта в 2D модели (выравнивание стенок по сетке)
- Добавлена поддержка тачевых экранов (рисование жестами, увеличение/уменьшение, прокрутка)
- Добавлена возможность назначать горячие клавиши
- Добавлен механизм автосохранения
- Добавлен пример с движением вокруг коробки
- Улучшено отображение ошибок, добавлена возможность их копировать в буфер обмена
- Исправлен механизм перетаскивания группы элементов
- Над связью теперь пишется условие, если оно задано
- Добавлена возможность задавать связи в виде кривых
- Исправлена работа с энкодерами в 2D модели
- Исправлен ряд падений 2D модели
- Исправлена обработка некорректных случаев использования блока "Условие"
- Множество других мелких исправлений


QReal:Robots 2.3.2
- Добавлена поддержка функций в блоке "Функция" (тригонометрические функции, модуль, генератор случайных чисел)
- Добавлен блок комментариев
- Добавлена деинсталляция предыдущей версии при установке новой
- Добавлено выравнивание узлов связей по сетке
- Добавлено всплывающее из палитры краткое описание блоков
- Добавлена возможность редактирования значений свойств, появляющихся при выделении блоков
- Уменьшена нагрузка на процессор при открытой 2D модели
- Обновлены картинки сенсоров света и цвета в 2D модели
- В стартовый диалог добавлены горячие клавиши
- Добавлена поддержка нескольких портов в блоке сброса энкодеров
- Из стартового диалога убрана кнопка "Помощь"
- Убраны некоторые устаревшие настройки
- Исправлен механизм вращения элементов мышью в 2D модели
- Временно убрана возможность импорта других проектов
- Исправлено поведение счетчика времени в 2D модели при корректном останове программы
- Исправлена проблема, вследствие которой появлялся шлейф на сцене от сенсоров
- Некоторые исправления в диалоге жестов мышью
- Исправлены некоторые сообщения об ошибке
- Добавлено автоматическое раскрытие групп в палитре
- Исправлена схема сохранения настроек палитры в реестре


QReal:Robots 2.3.1
- Исправлено медленное добавление элементов с большим количеством редактируемых свойств
- Усовершенствован интерфейс стартового диалога
- Исправлено выравнивание по сетке при добавлении нового блока
- Исправлена ошибка, в связи с которой невозможно было добавлять пробелы при редактировании свойств на сцене
- Добавлено автоматическое закрытие вкладок удаленных диаграмм
- Исправлено падение при попытке сохранить как картинку вкладку с текстом
- Свойство "Имя" элементов убрано
- Исправлено изменение положения блоков по двойному щелчку
- Убраны полосы прокрутки из диалога настроек роботов
- Расширена область для вытаскивания элементов из палитры
- Настройки видимости текста под блоками вынесены в пункт меню "Настройка"
- Добавлена возможность копирования текста сообщения об ошибке
- Улучшено отображение ошибок (добавлена поддержка формата rich text)
- Улучшения в работе механизма копирования-вставки
- Отформатирован пример movingAlongTheLine.qrs
- Исправлена компоновка кнопок с инструментами в 2D модели
- Исправлено очищение объектов в 2D модели при открытии другой диаграммы
- Исправлена загрузка положения робота в 2D модели


QReal:Robots 2.3.0
- Исправлено падение при закрытии программы при работающей интерпретации
- Исправлено падение при создании диаграммы при работающей интерпретации
- Исправлено падение при копировании/вставке
- Исправлен механизм копирования/вставки связей
- Исправлено падение при открытии проектов из explorer`а
- Исправлены названия пунктов главного меню на разных языках
- Введены горячие клавиши Ctrl + + и Ctrl + -, изменяющие масштаб сцены


QReal:Robots 2.3.0 RC1
- Добавлена поддержка логических выражений в условный блок
- Добавлена поддержка дробных типов в блоке "Функция"
- Сенсоры в 2D модели заменены картинками
- 2D модель мира и конфигурация сенсоров теперь привязываются к диаграмме
- Добавлена поддержка режима торможения и скольжения
- Налажена работа энкодеров в 2D модели
- Добавлено отображение времени в 2D модели
- Скорости вращения моторов в 2D модели приближены к реальным


QReal:Robots 2.2.0
- Налажена работа генераторов
- Cygwin больше не требуется для загрузки программы на робота
- Добавлено зашумление сенсоров и моторов в двумерной модели робота
- Добавлена очистка внесенных изменений после нажатия кнопки "Отмена" в настройках
- Исправлена ошибка с неполным разворачиванием окна при запуске среды


QReal:Robots 2.1.0
- Система переведена на qt 5
- Реализовано постоянное отображение основных свойств у блоков (отображение остальных свойств все также отключаемо в настройках)
- Реализовано отображение свойств выделенного элемента
- Исправлено медленное перечитывание значений сенсоров
- Добавлено пустое значение в свойстве "Условие" связей
- Добавлено логирование действий пользователя (для отслеживания некорректной работы, лог можно присылать нам с описанием ошибки)
- Исправлена работа сенсора касания в 2D модели
- Исправлено множество критических ошибок
- Исправлено замедление работы при перезапуске интерпретатора
- Линкеры перенесены на левую сторону, надпись "Линия соединения" убрана
- Изменение масштаба сцены теперь происходит по Ctrl+колесико, колесико мыши прокручивает сцену
- Добавлены горячие клавиши на открытие, сохранение, запуск и остановку интерпретатора (Ctrl+O, Ctrl+S, F5 и Shitf+F5 соответственно)
- Добавлена прокрутка сцены "рукой" при зажатом пробеле
- Внесены исправления в документации
- Обновлены примеры


QReal:Robots 2.0.2
- Исправлен отказ в открытии документации на некоторых компьютерах
- Добавлено упорядочивание и группировка свойств в контекстном меню встроенных линкеров
- Исправлено появление отключенного текста при бросании элемента в контейнер
- Исправлено поведение блоков ожидания


QReal:Robots 2.0.1
- Размер сетки уменьшен вдвое
- При вытаскивании из палитры блоки имеют тот же размер, что и на сцене
- Исправлена некорректная работа энкодеров в 2D модели при езде назад
- Исправлено падение программы при разрыве потока управления
- Значение сенсора света изменено на проценты


QReal:Robots 2.0.0
- Поддержаны коммуникации по I2C-шине через USB
- Иконки на панелях управления
- Множество других мелких исправлений


QReal:Robots 2.0.0 RC4:
- Изменения в документации
- Частично исправлена медленная работа 2D модели на некоторых компьютерах
- Несколько исправлений, связанных с сенсором цвета
- Исправлена некорректная работа таймеров в блоке звукового сигнала 2D модели
- Убрана возможность вращать сенсоры в 2D модели (кроме сонара)
- Добавлена поддержка сенсора света
- Исправлена работа блока ожидания света
- Убрано сообщение "Файл autosave.qrs не найден"
- Множество других мелких исправлений


QReal:Robots 2.0.0 RC3:

- Обновлена документация
- Исправлена ошибка перехода в полноэкранный режим
- Другие мелкие исправления


QReal:Robots 2.0.0 RC2:

- Улучшения в интерфейсах QReal и 2D модели
- Автонастройка сенсоров в 2D модели
- Настраиваемость видимости надписей под пиктограммами элементов
- Сглажена отрисовка линии карандашом в 2D модели
- Исправления в работе сенсоров
- Исправлена ошибка, связанная с изменением траектории при переключении скорости воспроизведения
- Сопоставление расширений *.qrs и QReal
- Множество других мелких исправлений
- Убран блок инициализации (теперь настройки сенсоров проводятся на панели сбоку)


QReal:Robots 2.0.0 RC1:

- Исправлено зависание при сохранении настроек
- Исправлена критическая ошибка, появляющаяся при сохранении настроек под Windows
- Исправлено некорректное поведение проверки конфигурации сенсоров
- Существенно улучшена 2D модель
	- Исправлено некорректное поведение стенок при добавлении на них других элементов
	- Исправлено некорректное поведение робота и сенсоров при их вращении
	- Исправлено некорректное поведение сенсоров в некоторых ситуациях
	- Исправлено "застревание" робота в стене
	- Улучшена отрисовка проигрывания роботом звука
	- Исправлено отслеживание удаления сенсоров на панели сбоку
	- Исправлено падение при очистке сцены
	- Добавлена возможность удалять элементы без полной очистки сцены
	- Исправлено множество других внутренних ошибок
- Исправлена коммуникация с сенсором расстояния на реальном роботе
